node('slave-node'){
    pipeline { 
    agent any 
    environment { 
        dockerImage = '' 
        registry = 'dockerkawther/kaoutherimagename'
        registryCredential = 'dockerhub_id'
    } 
    chkeckout scm
    
      
    stages { 
        stage( 'Checkout' ){ 
            steps { 
                git branch: 'main', url: 'https://github.com/kaouther-1/task2.git' 
                
            } 
            
        } 
        stage( 'Build docker image'){ 
            steps { 
                
                script { 
                    dockerImage = docker.build registry 
                    
                } 
                
            } 
            
        }
        stage ('Uploading image'){
            steps {
                script {
                    docker.withRegistry('', registryCredential) {
                        dockerImage.push()
                    }
                    
                }
                
            }
        }
        stage ('Docker stop container'){
            steps {
                sh 'docker ps -f name=kaouContainer -q | xargs --no-run-if-empty docker container stop'
                sh 'docker container is -a -fname=kaouContainer -q | xargs -r docker container rm'
            }
        }
        stage ('Docker Run') {
            steps {
                script {
                    dockerImage.run("-p 8096:8081 --rm --name kaouContainer")
                    
                }
            }
        }   
        
    }
    post {
        always {
            echo 'Test run completed'
            cucumber buildStatus: 'UNSTABLE', failedFeaturesNumber: 999, failedScenariosNumber: 999, failedStepsNumber: 3, fileIncludePattern: '*/.json', skippedStepsNumber: 999
        }
        success {
            echo 'Successfully!'
        }
        failure {
            echo 'Failed!'
        }
        unstable {
            echo 'This will run only if the run was marked as unstable'
        }
        changed {
            echo 'This will run only if the state of the Pipeline has changed'
            echo 'For example, if the Pipeline was previously failing but is now successful'
        }
    }
    options {
        timeout(time: 60, unit: 'MINUTES')
    }
    
}
}
